#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0010six4xi.py">
#<abstract4xi abstract = "zaps to direction six"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0010six4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import logging 
import os
import threading                
import signal
import sys
from math import pi
from math import sin
from math import cos 
from math import fabs
import weakref
import _thread
import _winapi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from zap2module4xi import ModuleKB2Zap4Xi
from print4xi      import print4xi
from time4xi       import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
# do NO define any globals for this kind of multiprocessing/thread module !!
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False 
#" 
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0010six4xi" usage = "target function for zap0000six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def zap0010six4xi(queue0010six, consumer_channel0010six, publisher_channel0010six, kb0010six):  
    '''
    returns layer 0010 of direction six
    ''' 
    # -------------------------------------------------------------------------------------------------
    # (Step 1/33)             
    # -------------------------------------------------------------------------------------------------   
    class2print  = 'zap0010six4xi'
    method2print = 'zap0010six4xi'
        
    # -------------------------------------------------------------------------------------------------
    # (Step 2/33)                      
    # -------------------------------------------------------------------------------------------------                                                               
    if ack2debug is True:
        print("\n (Step 2A/33) OF ZAP0010SIX4XI - STARTED TIME: ", time4xi())                                                       #  
        print("\n (Step 2B/33) OF ZAP0010SIX4XI -  QUEUE0010SIX: ", queue0010six)                                                   # <queue4xi.Queue4Xi object at 0x04DDB590> 
        print("\n (Step 2C/33) OF ZAP0010SIX4XI -  CONSUME_CHANNEL0010SIX: ", consumer_channel0010six)                              # <read-write PipeConnection, handle 284>
        print("\n (Step 2D/33) OF ZAP0010SIX4XI -  PUBLISHER_CHANNEL0010SIX: ", publisher_channel0010six)                           # <read-write PipeConnection, handle 288>
        print("\n (Step 2E/33) OF ZAP0010SIX4XI -  KB0010SIX: ", kb0010six)                                                         
        # {      '-16x7y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x7y-9z', 5: '#BEF781', 6: 61, 7: 10, 8: Decimal('19.6468827044'), 9: Decimal('9'), 10: 6, 11: '{passed; object-passed-to-sense-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, 
        #      '-15x45y-50z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x45y-50z', 5: '#4C7094', 6: 42, 7: 30, 8: Decimal('68.9202437605'), 9: Decimal('58'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}}, 
        #        '-16x5y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x5y-9z', 5: '#4C7094', 6: 57, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #         '-1x1y-1z': {'2xi': {1: 6, 2: 2, 3: {1: 6.283185307179586, 2: '#9A9591', 3: 1, 4: 6.283185307179586}, 4: 'dragon-1x1y-1z', 5: '#CB7C21', 6: 6, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-6Skeleton4Xi-started: 01:34:04 12/14/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}},
        #       '-13x12y-7z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x12y-7z', 5: '#4C7094', 6: 7, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #       '-12x13y-7z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-12x13y-7z', 5: '#4C7094', 6: 6, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #       '-13x12y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x12y-8z', 5: '#4C7094', 6: 12, 7: 30, 8: Decimal('19.4164878389'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #       '-14x10y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-14x10y-8z', 5: '#4C7094', 6: 14, 7: 30, 8: Decimal('18.973665961'), 9: Decimal('8'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #        '-15x8y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x8y-8z', 5: '#4C7094', 6: 43, 7: 30, 8: Decimal('18.7882942281'), 9: Decimal('8'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #        '-16x6y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x6y-9z', 5: '#BEF781', 6: 60, 7: 10, 8: Decimal('19.3132079158'), 9: Decimal('9'), 10: 6, 11: '{started; sense-object4xi-started: function sense_object4xi at 0x02A5F780; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense_object4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #       '-14x11y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-14x11y-8z', 5: '#4C7094', 6: 41, 7: 30, 8: Decimal('19.5192212959'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #      '-13x46y-50z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x46y-50z', 5: '#4C7094', 6: 13, 7: 30, 8: Decimal('69.1736944221'), 9: Decimal('59'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        # '-1029x2984y-961z': {'2xi': {1: 6, 2: 3300, 3: {1: 17105971.998796422, 2: '#9A9591', 3: 16, 4: 1069123.2499247764}, 4: 'dragon-1029x2984y-961z', 5: '#F55A5A', 6: 3307, 7: 1, 8: 3300, 9: 0, 10: 6, 11: '{started; sense-of-SuperCluster4Xi-started: 01:34:05 12/14/10 Pacific Standard Time}', 12: 'super', 13: 1}, '8xi': {}, '4xi': {}},
        #        '-16x4y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x4y-9z', 5: '#4C7094', 6: 56, 7: 30, 8: Decimal('18.7882942281'), 9: Decimal('8'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #'-1002x1878y-2389z': {'2xi': {1: 6, 2: 3200, 3: {1: 16084954.386379741, 2: '#9A9591', 3: 16, 4: 1005309.6491487338}, 4: 'dragon-1002x1878y-2389z', 5: '#4C7094', 6: 3230, 7: 30, 8: 3200, 9: 0, 10: 6, 11: '{started; sense-of-Cluster4Xi-started: 01:34:04 12/14/10 Pacific Standard Time}', 12: 'cluster', 13: 1}, '8xi': {}, '4xi': {}},
        #      '-17x44y-51z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-17x44y-51z', 5: '#BEF781', 6: 62, 7: 10, 8: Decimal('69.4694177318'), 9: Decimal('59'), 10: 6, 11: "{returning; kb2xi-returning-by-sense-object4xi: {'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense_object4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #      '-11x47y-49z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-11x47y-49z', 5: '#4C7094', 6: 5, 7: 30, 8: Decimal('68.7822651561'), 9: Decimal('58'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #        '-15x9y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x9y-8z', 5: '#4C7094', 6: 55, 7: 30, 8: Decimal('19.2353840617'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1}, '8xi': {}, '4xi': {}}}
        # 
        
    message2print = "{(Step 2A/33) started" + "; zap0010six4xi-started: " + str(zap0010six4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              # 
        
    message2print = "{(Step 2B/33) passed" + "; queue0010six-passed-to-zap0010six4xi: " + str(queue0010six) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              # 
                  
    message2print = "{(Step 2C/33) passed" + "; consumer-channel0010six-passed-to-zap0010six4xi: " + str(consumer_channel0010six) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #    
    
    message2print = "{(Step 2D/33) passed" + "; publisher-channel0010six-passed-to-zap0010six4xi: " + str(publisher_channel0010six) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #          
    
    message2print = "{(Step 2E/33) passed" + "; kb0010six-passed-to-zap0010six4xi: " + str(kb0010six) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #          
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/33)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ack2debug is True:
        print("\n (Step 3/33) OF ZAP0010SIX4XI - TRYING TO PUT LAYER 0010 TO QUEUE0010SIX: ", queue0010six)                         # 
    message2print = "{(Step 3/33) using" + "; queue0010six-using-by-zap0010six4xi: " + str(queue0010six)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
            
    ack0010put4six = False                                                                                                                           

    # ------------------------------------------------------------------------------------- 
    # (Step 4/33) 
    # -------------------------------------------------------------------------------------                 

    # ------------------------------------------------------------------------------------- 
    # CONSTANTS VALID FOR ANY ZAP-KOWLEDGEBASE  
    # -------------------------------------------------------------------------------------     
    key2sense       = '2xi'
    key2reason      = '4xi'
    key2ace         = '8xi'
    key2direction   = 1
    key2distance    = 2
    key2layer       = 3
    
    key2area4layer  = 1
    key2color4layer = 2
    key2qty4layer   = 3
    key2area4node   = 4
    
    key2identity    = 4 
    key2color       = 5
    key2fire        = 6
    key2cluster     = 7
    key2ray         = 8
    key2deviation   = 9 
    key2super       = 10
    key2message     = 11
    key2actor       = 12
    key2type        = 13
    key2home        = 14
    key2previous    = 15
    key2next        = 16
    key2last        = 17
    key2first       = 18
    key2module      = 19
      
    # ------------------------------------------------------------------------------------- 
    # (Step 5/33) CONSTANTS VALID FOR LAYER 0010 OF DIRECTION SIX 
    # ------------------------------------------------------------------------------------- 
    direction0010sense4six = 6                                                                                                      # DIRECTION
    message2print = "{(Step 5A/33) set" + "; direction0010sense4six-set-by-zap0010six4xi to: " + str(direction0010sense4six)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
            
    distance0010sense4six  = 10                                                                                                     # DISTANCE = LAYER
    message2print = "{(Step 5B/33) set" + "; distance0010sense4six-set-by-zap0010six4xi to: " + str(distance0010sense4six)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #  
                                                                 
    # ------------------------------------------------------------------------------------- 
    # (Step 6/33) CREATE NEW KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------         
    keys0010six = kb0010six.keys()
    kb0010six2put = {}
    for key0010six in keys0010six:
        if ((kb0010six[key0010six] [key2sense] [key2distance] == distance0010sense4six) and (kb0010six[key0010six] [key2sense] [key2direction] == direction0010sense4six)):
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------        
            if ack2debug is True:
                print("\n (Step 6A0/33) OF ZAP0010SIX4XI - LEVEL NODE'S KEY: ", key0010six, " CONTENT: ", kb0010six[key0010six])
            #  
            message2print = "{(Step 6A0/33) set" + "; nodekey-set-by-zap0010six4xi to: " + str(key0010six)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                      # -16x7y-9z                         
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------         
            try:                                                                                                                    
                kb0010six2put [key0010six] = {}                                                                                     # SAVE THE LAYER OF THE REQUIRED DIRECTION
            except:
                print("\n (Step 6A/33) OF ZAP0010SIX4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010SIX: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            try:         
                kb0010six2put [key0010six] [key2sense]  = {}                                                                        # SENSE
            except:
                print("\n (Step 6B/33) OF ZAP0010SIX4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010SIX: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                   
            if ack2debug is True:
                print("\n (Step 6C/33) OF ZAP0010SIX4XI - TRYING TO SET DIRECTION AT: ", kb0010six [key0010six] [key2sense] )     # 
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2direction] = kb0010six [key0010six] [key2sense] [key2direction]         # DIRECTION 
                message2print = "{(Step 6D/33) set" + "; direction-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2direction])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                         
            except:
                print("\n (Step 6E/33) OF ZAP0010SIX4XI *** FAILED TO SET DIRECTION AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6F/33) OF ZAP0010SIX4XI - TRYING TO SET DISTANCE AT: ", kb0010six [key0010six] [key2sense] )      #                
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2distance] = kb0010six [key0010six][key2sense] [key2distance]            # DISTANCE
                message2print = "{(Step 6G/33) set" + "; distance-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2distance])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
            except:
                print("\n (Step 6B4B/33) OF ZAP0010SIX4XI *** FAILED TO SET DISTANCE AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B5A/33) OF ZAP0010SIX4XI - TRYING TO SET LAYER AT: ", kb0010six [key0010six] [key2sense] )       #        
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2layer] = {}                                                             # LAYER
                message2print = "{(Step 6B5B/33) set" + "; layer-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B5Z/33) OF ZAP0010SIX4XI *** FAILED TO SET LAYER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B6A/33) OF ZAP0010SIX4XI - TRYING TO SET AREA FOR LAYER AT: ", kb0010six [key0010six]  [key2sense] [key2layer] )                   
            try:                                                                                                                    #                     
                kb0010six2put [key0010six] [key2sense] [key2layer] [key2area4layer] = kb0010six [key0010six] [key2sense] [key2layer] [key2area4layer] 
                                                                                                                                    # AREA2LAYER
                message2print = "{(Step 6B6B/33) set" + "; area2layer-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2layer] [key2area4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #               
            except:
                print("\n (Step 6B6Z/33) OF ZAP0010SIX4XI *** FAILED TO SET AREA FOR LAYER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B7A/33) OF ZAP0010SIX4XI - TRYING TO SET COLOR FOR LAYER AT: ", kb0010six [key0010six]  [key2sense] [key2layer] )
                                                                                                                                    #                    
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2layer] [key2color4layer] = kb0010six [key0010six] [key2sense] [key2layer] [key2color4layer]
                                                                                                                                    # 
                message2print = "{(Step 6B7B/33) set" + "; color2layer-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2layer] [key2color4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #             
            except:
                print("\n (Step 6B7Z/33) OF ZAP0010SIX4XI *** FAILED TO SET COLOR FOR LAYER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B8A/33) OF ZAP0010SIX4XI - TRYING TO SET QUANTITY FOR LAYER: ", kb0010six [key0010six]  [key2sense] [key2layer]  )
                                                                                                                                    #                         
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2layer] [key2qty4layer] = kb0010six [key0010six] [key2sense] [key2layer] [key2qty4layer]
                                                                                                                                    # 
                message2print = "{(Step 6B8B/33) set" + "; qty2layer-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2layer] [key2qty4layer])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B8Z/33) OF ZAP0010SIX4XI *** FAILED TO SET QUANTITY FOR LAYER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B9A/33) OF ZAP0010SIX4XI - TRYING TO SET AREA FOR NODE: ", kb0010six  [key0010six] [key2sense] [key2layer]  )
                                                                                                                                    #                           
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2layer] [key2area4node] = kb0010six [key0010six] [key2sense] [key2layer] [key2area4node]
                                                                                                                                    # AREA2NODE
                message2print = "{(Step 6B9B/33) set" + "; area2node-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2layer] [key2area4node])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #              
            except:
                print("\n (Step 6B9Z/33) OF ZAP0010SIX4XI *** FAILED TO SET AREA FOR NODE AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B10A/33) OF ZAP0010SIX4XI - TRYING TO SET IDENTITY: ", kb0010six  [key0010six] [key2sense] )  #                
            try:                              
                kb0010six2put [key0010six] [key2sense] [key2identity] = kb0010six[ key0010six] [key2sense] [key2identity]           # IDENTITY
                message2print = "{(Step 6B10B/33) set" + "; identity-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2identity])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B10Z/33) OF ZAP0010SIX4XI *** FAILED TO SET IDENTITY AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B11A/33) OF ZAP0010SIX4XI - TRYING TO SET COLOR: ", kb0010six [key0010six]  [key2sense] )     #               
            try:                              
                kb0010six2put [key0010six] [key2sense] [key2color] = kb0010six [key0010six]  [key2sense] [key2color]                # COLOR
                message2print = "{(Step 6B11B/33) set" + "; color-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2color])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B11Z/33) OF ZAP0010SIX4XI *** FAILED TO SET COLOR AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B12A/33) OF ZAP0010SIX4XI - TRYING TO SET FIRE: ", kb0010six [key0010six]  [key2sense] )      # 
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2fire] = kb0010six [key0010six]  [key2sense] [key2fire]                  # FIRE 
                message2print = "{STEP 2B12A/33) set" + "; fire-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2fire])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                        
            except:
                print("\n (Step 6B12Z/33) OF ZAP0010SIX4XI *** FAILED TO SET FIRE AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B13A/33) OF ZAP0010SIX4XI - TRYING TO SET CLUSTER: ", kb0010six [key0010six]  [key2sense] )    # 
                                  
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2cluster] = kb0010six [key0010six]  [key2sense] [key2cluster]            # 
                message2print = "{(Step 6B13B/33) set" + "; cluster-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2cluster])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B13Z/33) OF ZAP0010SIX4XI *** FAILED TO SET CLUSTER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B14A/33) OF ZAP0010SIX4XI - TRYING TO SET RAY: ", kb0010six [key0010six]  [key2sense] )        #             
            try:                             
                kb0010six2put[key0010six] [key2sense] [key2ray] = kb0010six [key0010six]  [key2sense] [key2ray]                     # RAY 
                message2print = "{(Step 6B14B/33) set" + "; ray-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put[key0010six] [key2sense] [key2ray])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B14Z/33) OF ZAP0010SIX4XI *** FAILED TO SET RAY AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B15A/33) OF ZAP0010SIX4XI - TRYING TO SET DEVIATION: ", kb0010six [key0010six]  [key2sense] )  #                 
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2deviation] = kb0010six [key0010six]  [key2sense] [key2deviation]        # DEVIATION
                message2print = "{(Step 6B15B/33) set" + "; deviation-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2deviation])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B15Z/33) OF ZAP0010SIX4XI *** FAILED TO SET DEVIATION AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B16A/33) OF ZAP0010SIX4XI - TRYING TO SET SUPER: ", kb0010six [key0010six]  [key2sense] )      #                
            try:                              
                kb0010six2put[key0010six] [key2sense] [key2super] = kb0010six [key0010six]  [key2sense] [key2super]                 # SUPER
                message2print = "{(Step 6B16B/33) set" + "; super-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put[key0010six] [key2sense] [key2super])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B16Z/33) OF ZAP0010SIX4XI *** FAILED TO SET SUPER AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B17A/33) OF ZAP0010SIX4XI - TRYING TO SET MESSAGE: ", kb0010six [key0010six]  [key2sense] )    #               
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2message] = kb0010six [key0010six]  [key2sense] [key2message]            # MESSAGE
                message2print = "{(Step 6B17B/33) set" + "; message-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 
                                 
            except:
                print("\n (Step 6B17C/33) OF ZAP0010SIX4XI - TRYING TO GENERATE DUMMY MESSAGE TO: ", kb0010six [key0010six]  [key2sense])     
                try:
                                                                                                                                    # set default message
                    kb0010six2put [key0010six] [key2sense] [key2message] = "{(Step 6B17C/33) yielded" + "; key2message-yielded-by-zap0010six4xi: " + str(key2message)  + "; time: " + time4xi() + "}"
                    
                    message2print = "{(Step 6B17D/33) set" + "; message-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                except:    
                    print("\n (Step 6B17Z/33) OF ZAP0010SIX4XI *** FAILED TO SET MESSAGE AT LAYER 0010: ", key0010six) 
                                       
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B18A/33) OF ZAP0010SIX4XI - TRYING TO SET ACTOR: ", kb0010six [key0010six]  [key2sense] )      #                  
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2actor] = kb0010six [key0010six]  [key2sense] [key2actor]                # ACTOR 
                message2print = "{(Step 6B18B/33) set" + "; actor-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #              
            except:
                try:
                    kb0010six2put [key0010six] [key2sense] [key2actor] = 'zap0010six4xi'                                            # THIS BECOMES THE ACTOR!
                    message2print = "{(Step 6B18C/33) set" + "; actor-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                except:                            
                    print("\n (Step 6B18Z/33) OF ZAP0010SIX4XI *** FAILED TO SET ACTOR AT LAYER 0010 TO QUEUE0010TWO: ", key0010six)
                    # 
                
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B19A/33) OF ZAP0010SIX4XI - TRYING TO SET TYPE: ", kb0010six [key0010six]  [key2sense] )       #               
            try:                             
                kb0010six2put [key0010six] [key2sense] [key2type] = kb0010six [key0010six]  [key2sense] [key2type]                  # TYPE 
                message2print = "{(Step 6B19B/33) set" + "; type-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                try:
                    kb0010six2put [key0010six] [key2sense] [key2type] = 1                                                           # THIS IS function
                    message2print = "{(Step 6B19C/33) set" + "; type-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              #                
                except:
                    print("\n (Step 6B19Z/33) OF ZAP0010SIX4XI *** FAILED TO SET TYPE AT LAYER 0010 TO QUEUE0010TWO: ", key0010six)
                    # 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B20A/33) OF ZAP0010SIX4XI - TRYING TO SET REASON: ", kb0010six [key0010six]  )                 #                   
            try:                              
                kb0010six2put [key0010six] [key2reason] = kb0010six [key0010six] [key2reason]                                       # REASON
                message2print = "{(Step 6B20B/33) set" + "; reason-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2reason])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B20Z/33) OF ZAP0010SIX4XI *** FAILED TO SET REASON AT LAYER 0010: ", key0010six)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B21A/33) OF ZAP0010SIX4XI - TRYING TO SET ACE: ", kb0010six [key0010six]   )                   #              
            try:                             
                kb0010six2put [key0010six] [key2ace]    = kb0010six [key0010six] [key2ace]                                          # ACE
                message2print = "{(Step 6B21B/33) set" + "; ace-of-zap-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2ace])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B21Z/33) OF ZAP0010SIX4XI *** FAILED TO SET ACE AT LAYER 0010: ", key0010six)
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B22A/33) OF ZAP0010SIX4XI - TRYING TO SET MODULE: ", kb0010six [key0010six]  [key2sense] )      #                 
                                                                                              
            try:
                key2try = kb0010six [key0010six]  [key2sense] [key2actor]
                if ack2debug is True:
                    print("\n (Step 6B22B/33) OF ZAP0010SIX4XI - KEY2TRY: ", key2try) 
                    
                kb0010six2put [key0010six] [key2sense] [key2module] = ModuleKB2Zap4Xi[key2try]                                   
                
                message2print = "{(Step 6B22C/33) set" + "; module-set-by-zap0010six4xi to: " + str(kb0010six2put [key0010six] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                  # 

            except:
                try:
                    kb0010six2put [key0010six] [key2sense] [key2module] = 'zap0010six4xi.py'                                        # THIS BECOMES THE MODULE IN EXCEPTIONS
                    print("\n (Step 6B22Z1/33) OF ZAP0010SIX4XI ** YIELDED - SET MODULE TO: ", kb0010six2put [key0010six] [key2sense] [key2module])
                    message2print = "{(Step 6B22Z1/33) yielded" + "; module-yielded-by-zap2actor4xi: " + str(kb0010six2put [key0010six] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                          
                except:    
                    print("\n (Step 6B22Z2/33) OF ZAP0010SIX4XI *** FAILED TO SET MODULE AT LAYER 0010: ", key0010six)              #
                    #          
                    
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
        else:
            pass
            
    # -------------------------------------------------------------------------------------------------
    # (Step 7/33) BUILD LINK LIST AT AT LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:
        print("\n (Step 7A/33) OF ZAP0010SIX4XI - TRYING TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX FROM : ", kb0010six2put)
                                                                                                                                    # 
                                                                                                                                    # 
                                                                                                                                    # 

    try:                             
        keys0010six2put = kb0010six2put.keys()                                                                                      # 
        kb0010link4six = {} 
        order2link = 1
        for key0010six2put in keys0010six2put:
            key0010navigation4six = kb0010six2put [key0010six2put] [key2sense] [key2fire]                                           # input nodes embed fire number 
            kb0010link4six [order2link] = {}
            kb0010link4six [order2link] [key0010six2put] = {}
            kb0010link4six [order2link] [key0010six2put] [1]    = 0                                                                 # order                                                                                                                                 
            kb0010link4six [order2link] [key0010six2put] [2]    = '0x0y0z'                                                          # home                                                           
            kb0010link4six [order2link] [key0010six2put] [3]    = '0x0y0z'                                                          # previous
            kb0010link4six [order2link] [key0010six2put] [4]    = '0x0y0z'                                                          # next
            kb0010link4six [order2link] [key0010six2put] [5]    = '0x0y0z'                                                          # last
            kb0010link4six [order2link] [key0010six2put] [6]    = '0x0y0z'                                                          # first
            kb0010link4six [order2link] [key0010six2put] [7]    = 0                                                                 # fire number
            order2link = order2link + 1
            
        keys0010link4six = kb0010link4six.keys()                                                                                    # keys of input knowledgebase
        if ack2debug is True:
            for key0010link4six in sorted(keys0010link4six):                                                                        # keys of linklist
                if ack2debug is True:
                    print("\n (Step 7B/33) OF ZAP0010SIX4XI KB0010LINK4SIX[", key0010link4six, "]: ", kb0010link4six[key0010link4six])   
                                                                                                                                    # 
                                                                                                                                    # 
    except:
        print("\n (Step 7D/33) OF ZAP0010SIX4XI *** FAILED TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX: ", kb0010link4six) 
        message2print = "{(Step 7E/33) failed" + "; kb0010link4six-failed-by-zap0010six4xi: " + str(kb0010link4six) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
    # -------------------------------------------------------------------------------------------------
    # (Step 8A/33) BUILD FIRE LIST
    # -------------------------------------------------------------------------------------------------                       
    if ack2debug is True:
        print("\n (Step 8A1/33) OF ZAP0010SIX4XI - TRYING BUILD FIRE KNOWLEDGEBASE")
    try:
        kb0010fire4six = {}
        keys0010six2put = kb0010six2put.keys()                                                                                      #            
        for key0010six2put in keys0010six2put:
            key0010fire4six = kb0010six2put [key0010six2put] [key2sense] [key2fire]                                                 # 
            kb0010fire4six[key0010fire4six] = key0010six2put                                                                        # 
        if ack2debug is True:
            print("\n (Step 8A2/33) OF ZAP0010SIX4XI - BUILT FIRE KNOWLEDGEBASE: ", kb0010fire4six)                                 
            # {5: '-11x47y-49z', 6: '-12x13y-7z', 7: '-13x12y-7z', 41: '-14x11y-8z', 42: '-15x45y-50z', 43: '-15x8y-8z', 12: '-13x12y-8z', 
            # 13: '-13x46y-50z', 14: '-14x10y-8z', 55: '-15x9y-8z', 56: '-16x4y-9z', 57: '-16x5y-9z', 60: '-16x6y-9z', 61: '-16x7y-9z', 62: '-17x44y-51z'}
          
    except:
        print("\n (Step 8A3/33) OF ZAP0010SIX4XI *** FAILED BUILD FIRE KNOWLEDGEBASE")
        message2print = "{(Step 8Z/33) failed" + "; kb0010fire4six-failed-by-zap0010six4xi: " + str(kb0010fire4six) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
       
    # -----------------------------------------------------------------------------------------------------------------------------
    # (Step 8C/33) EMBED FIRES TO LINK LIST  
    # -----------------------------------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8C1/33) OF ZAP0010SIX4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX")     

    keys2fire = kb0010fire4six.keys()
    rank2xi = 1
    for key2fire in sorted(keys2fire):                                                                                              #                                                                    
        # -------------------------------------------------------------------------------------------------------------------------
        # 
        # -------------------------------------------------------------------------------------------------------------------------                                                                                     
        if ack2debug is True:
            print("\n (Step 8C5/33) OF ZAP0010SIX4XI - KEY2FIRE: ", key2fire)                                                       # 

        coordinate2rank = kb0010fire4six[key2fire]                                                                                  #                                                             
        
        
        keys2link = kb0010link4six.keys()                                                                                           
        for keylink in keys2link:                                                                                                   # 
            try:
                if kb0010link4six [keylink] [coordinate2rank]  [7] == 0:            
                    kb0010link4six [keylink] [coordinate2rank] [7] = key2fire                                                       # 
                if kb0010link4six [keylink] [coordinate2rank]  [1] == 0:
                    kb0010link4six [keylink] [coordinate2rank] [1] = rank2xi                                                        # 
                    rank2xi = rank2xi + 1
                if ack2debug is True:    
                    print("\n (Step 8D10/33) OF ZAP0010SIX4XI - MATCH: UPDATED KB0010LINK4SIX: ", kb0010link4six)                   # 
                                                                                                                                    # 
                                                                                                                                    # 
            except:
                pass               

    
    # ---------------------------------------------------------------------------------------------------------------------
    # (Step 8D/33) PRINT LINKING LIST WITH SIX FIRE EMBEDDED  
    # ---------------------------------------------------------------------------------------------------------------------                    
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010SIX4XI - TRYING TO PRINT LINKING LIST WITH SIX FIRE EMBEDDED ")   
        try: 
            print("\n (Step 8C7/33) OF ZAP0010SIX4XI - KB0010LINK4SIX: ", kb0010link4six)                                           # 
        except:                                                                                                                         
            print("\n (Step 8Z4/33) OF ZAP0010SIX4XI *** FAILED TO PRINT LINKING LIST WITH SIX FIRE EMBEDDED") 
                        
            
    # -------------------------------------------------------------------------------------------------
    # (Step 8E/33) EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0010SIX4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")      
                                                                                                                           
    keys0010six2put = kb0010six2put.keys()
                                               
    # -------------------------------------------------------------------------------------------------
    # THE LATEST VALUES TO BE CHANGED DURING WALKTROUGHS
    # -------------------------------------------------------------------------------------------------     
    origin2link         = '0x0y0z'                                                                                                  # link to origin
    home2link           = '-0x-0y-0z'                                                                                               # unresolved-home  
    previous2link       = '-0x-0y-0z'                                                                                               # unresolved-previous 
    next2link           = '+0x+0y+0z'                                                                                               # unresolved-next 
    first2link          = '+0x+0y+0z'                                                                                               # unresolved-first 
    last2link           = '+0x+0y+0z'                                                                                               # unresolved-last 
    max2last            = 0                                                                                                         # maximun order number for the last node - default 0

                                                                                                             
    # -------------------------------------------------------------------------------------------------
    # (Step 8E1/33) THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8E1a/33) OF ZAP0010SIX4XI - TRYING THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")               
    for key0010six2put in keys0010six2put:
        # -------------------------------------------------------------------------------------------------
        # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX
        # -------------------------------------------------------------------------------------------------                                                                                      
        if ack2debug is True:
            print("\n (Step 8E1b/33) OF ZAP0010SIX4XI KB0010LINK4SIX - KEY0010SIX2PUT: ", key0010six2put)                           # 
        keys2link = kb0010link4six.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 8E1c/33) OF ZAP0010SIX4XI KB0010LINK4SIX - KEY2LINK: ", key2link)                                   # 
            # ---------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION SIX
            # ---------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4six[key2link]
                keys2check = kb2check.keys()
                for key2check in keys2check:
                    # ---------------------------------------------------------------------------------------------
                    # NODE(S) OF LINK LIST AT LAYER 0010 OF DIRECTION SIX
                    # -------------------------------------------------------------------------------------------                   
                    if key2check == key0010six2put: 
                        if ack2debug is True:
                            print("\n (Step 8E1d/33) OF ZAP0010SIX4XI KB0010LINK4SIX - MATCH WITH KEY0010SIX2PUT: ", key0010six2put) 
                                                                                                                                    #                                                                         
                        if kb0010link4six[key2link] [key0010six2put] [1] == 1:                                                      # the first nsix in fire order at this layer to required direction
                            if ack2debug is True:
                                print("\n (Step 8E1e/33) OF ZAP0010SIX4XI KB0010LINK4SIX - THE FIRT NODE: ", key0010six2put)        # 
                                  
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                                              
                            first2link        = key0010six2put                                                                      # first-link points to this node                        
                            if ack2debug is True:
                                print("\n (Step 8E1f/33) OF ZAP0010SIX4XI KB0010LINK4SIX - SET FIRST2LINK TO: ", first2link)            
                                
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010six2put [key0010six2put] [key2sense] [key2home]     = home2link                                   # 
                                                                     
                                                     
                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER THE FIRST NODE
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4six[key2link] [key0010six2put] [1] > max2last:
                                last2link    = key0010six2put                                                                       # 
                                max2last     = kb0010link4six[key2link] [key0010six2put] [1]                                        # 
                        else:
                            if ack2debug is True:
                                print("\n (Step 8E1g/33) OF ZAP0010SIX4XI KB0010LINK4SIX - THE ", kb0010link4six[key2link] [key0010six2put] [1], ". NODE: ", key0010six2put)
                                                                                                                                    # 
                                                                                                                                    #         
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------
                                                                                                                                    # 
                            
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0010six2put [key0010six2put] [key2sense] [key2home]     = home2link                                   # only link to be updated for output!

                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER TYPICAL NODE 
                            # --------------------------------------------------------------------------------- 
                            if kb0010link4six[key2link] [key0010six2put] [1] > max2last:
                                last2link    = key0010six2put                                                                       # 
                                max2last     = kb0010link4six[key2link] [key0010six2put] [1]                                        #                   
                                                      
                           
                    else:
                        if ack2debug is True:
                            print("\n (Step 8E1h/33) OF ZAP0010SIX4XI KEY0010SIX2PUT - PASSED KEY2LINK: ", key2link, " WITH NODE: ", key0010six2put)              
            except:
                pass                                                                                                                # nodes with different links
    # -------------------------------------------------------------------------------------------------
    # 
    # -------------------------------------------------------------------------------------------------                                  
    if ack2debug is True:
        # key2home        = 14 [OK]
        print("\n (Step 8E1i/33) OF ZAP0010SIX4XI - LATEST FIRST: ", first2link)                                                    # 
        print("\n (Step 8E1j/33) OF ZAP0010SIX4XI - LATEST LAST: ", last2link)                                                      #                            
        print("\n (Step 8E1k/33) OF ZAP0010SIX4XI - LATEST MAX ORDER: ",max2last)                                                   #           
                
    # -------------------------------------------------------------------------------------------------
    # (Step 9/33) THE SECOND WALKTROUGH TO EMBED THE FIRST AND LAST LINK TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 9A/33) OF ZAP0010SIX4XI - TRYING TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
    try:      
        for key0010six2put in keys0010six2put:
            # ---------------------------------------------------------------------------------------------
            # KNOWLEDGEBASE AT LAYER 0010 OF DIRECTION SIX
            # ---------------------------------------------------------------------------------------------    
            kb0010six2put [key0010six2put] [key2sense] [key2first] = first2link
            kb0010six2put [key0010six2put] [key2sense] [key2last]  = last2link
        # ------------------------------------------------------------------------------------------------- 
        #
        # -------------------------------------------------------------------------------------------------             
        if ack2debug is True:    
            print("\n (Step 9B/33) OF ZAP0010SIX4XI - UPDATED THE FIRST AND LAST LINK TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
            print("\n (Step 9C/33) OF ZAP0010SIX4XI - KB0010SIX2PUT: ", kb0010six2put)
            # 
 
    except:        
        print("\n (Step 9Z/33) OF ZAP0010SIX4XI *** FAILED TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
        message2print = "{(Step 9Z/33) failed" + "; kb0010six2put-failed-by-zap0010six4xi: " + str(kb0010six2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                  
    # -------------------------------------------------------------------------------------------------
    # (Step 10/33) THE THIRD WALKTROUGH TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 10A/33) OF ZAP0010SIX4XI - TRYING TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
    try:    
        # 
        
        keys2link = kb0010link4six.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 10B/33) OF ZAP0010SIX4XI KB0010LINK4SIX - KEY2LINK: ", key2link)                                    # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION SIX
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4six[key2link]                                                                                 # 
                keys2check = kb2check.keys()                                                                                        # 
                for key2check in keys2check: 
                                                                                                                                    #  
                    # -------------------------------------------------------------------------------------------
                    # PREVIOUS LINK
                    # -------------------------------------------------------------------------------------------                                                                                                                                             
                    if kb2check [key2check] [1] == 1:                                                                               # 1 = the first node
                        # ---------------------------------------------------------------------------------------
                        # FIRST NODE - UNRESOLVED-PREVIOUS FOR THE MAIN TO SOLVE FROM PREVIOUS LAYER LAST 
                        # ---------------------------------------------------------------------------------------
                        kb0010six2put [key2check] [key2sense] [key2previous] = previous2link                                        # 
                        if ack2debug is True:
                            print("\n (Step 10C/33) OF ZAP0010SIX4XI - PREVIOUS SET TO: ", previous2link, "  FOR THE FIRST NODE: ", key2check)
                                                                                                                                    # 
                    else:
                        # ---------------------------------------------------------------------------------------
                        # PREVIOUS TO OTHERS
                        # ---------------------------------------------------------------------------------------                 
                        order2previous = kb2check [key2check] [1] - 1                                                               # 
                        if ack2debug is True:
                            print("\n (Step 10D/33) OF ZAP0010SIX4XI ORDER OF PREVIOUS TO HUNT: ", order2previous, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                        keys2hunt1 = kb0010link4six.keys()                                  
                        for key2hunt1 in keys2hunt1:                                                                                # 
                            # -----------------------------------------------------------------------------------
                            # HUNT PREVIOUS
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt1 = kb0010link4six[key2hunt1]                                                              # 
                            keys2check4hunt1 = kb2check4hunt1.keys()                                                                # 
                            for key2check4hunt1 in keys2check4hunt1:
                                if kb2check4hunt1 [key2check4hunt1] [1] == order2previous:                                          # 
                                    kb0010six2put [key2check] [key2sense] [key2previous] = key2check4hunt1                          # 
                                    if ack2debug is True:
                                        print("\n (Step 10E/33) OF ZAP0010SIX4XI - PREVIOUS SET TO: ", key2check4hunt1, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                            else:
                                pass

            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        #                                          
        if ack2debug is True:    
            print("\n (Step 10B/33) OF ZAP0010SIX4XI - UPDATED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
            print("\n (Step 10C/33) OF ZAP0010SIX4XI - KB0010SIX2PUT: ", kb0010six2put)
            # 
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0010SIX4XI *** FAILED TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
        message2print = "{(Step 10Z/33) failed" + "; kb0010six2put-failed-by-zap0010six4xi: " + str(kb0010six2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
    # -------------------------------------------------------------------------------------------------
    # (Step 11/33) THE THIRD WALKTROUGH TO EMBED NEXT LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 11A/33) OF ZAP0010SIX4XI - TRYING TO EMBED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
    try:
        # input link list:    
        # 
        
        keys2link = kb0010link4six.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 11B/33) OF ZAP0010SIX4XI KB0010LINK4SIX - KEY2LINK: ", key2link)                                    # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0010 OF DIRECTION SIX
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0010link4six[key2link]                                                                                 # 
                keys2check = kb2check.keys()                                                                                        # 

                for key2check in keys2check:                 
                    # -------------------------------------------------------------------------------------------
                    # NEXT LINK
                    # -------------------------------------------------------------------------------------------                                 
                    if kb2check [key2check] [1] == max2last:
                        # ---------------------------------------------------------------------------------------
                        # LAST NODE - UNRESOLVED-NEXT FOR THE MAIN TO SOLVE FROM NEXT LAYER FIRST
                        # --------------------------------------------------------------------------------------- 
                        kb0010six2put [key2check] [key2sense] [key2next] = next2link                                                # 
                        if ack2debug is True:
                            print("\n (Step 11F/33) OF ZAP0010SIX4XI - NEXT SET TO: ", next2link, "  FOR LAST NODE: ", key2check)
                                                                                                                                    #                      
                    else:
                        # ---------------------------------------------------------------------------------------
                        # NEXT TO OTHERS
                        # ---------------------------------------------------------------------------------------                     
                        order2next = kb2check [key2check] [1] + 1                                                                   # 
                        if ack2debug is True:
                            print("\n (Step 11E/33) OF ZAP0010SIX4XI ORDER OF NEXT TO HUNT: ", order2next, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    #                    
                        keys2hunt2 = kb0010link4six.keys()                         
                        for key2hunt2 in keys2hunt2:
                            # -----------------------------------------------------------------------------------
                            # HUNT NEXT
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt2 = kb0010link4six[key2hunt2] 
                            keys2check4hunt2 = kb2check4hunt2.keys()
                            for key2check4hunt2 in keys2check4hunt2: 
                                if kb2check4hunt2 [key2check4hunt2] [1] == order2next:                                                
                                    kb0010six2put [key2check] [key2sense] [key2next] = key2check4hunt2                              # 
                                    if ack2debug is True:
                                        print("\n (Step 11G/33) OF ZAP0010SIX4XI - NEXT SET TO: ", key2check4hunt2, "  FOR NODE: ", key2check)
                                                                                                                                    #            
                                else:
                                    pass
            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # order numbers:
        # {5: '-11x47y-49z', 6: '-12x13y-7z', 7: '-13x12y-7z', 41: '-14x11y-8z', 42: '-15x45y-50z', 43: '-15x8y-8z', 12: '-13x12y-8z', 
        # 13: '-13x46y-50z', 14: '-14x10y-8z', 55: '-15x9y-8z', 56: '-16x4y-9z', 57: '-16x5y-9z', 60: '-16x6y-9z', 61: '-16x7y-9z', 62: '-17x44y-51z'}       
        # keys:
        # key2direction   = 1,  key2distance    = 2,  key2layer       = 3   {key2area4layer  = 1, key2color4layer = 2, key2qty4layer   = 3, key2area4node   = 4}
        # key2identity    = 4,  key2color       = 5,  key2fire        = 6,  key2cluster     = 7,  key2ray         = 8, key2deviation   = 9, key2super       = 10
        # key2message     = 11, key2actor       = 12, key2type        = 13, key2home        = 14
        # key2previous    = 15, key2next        = 16, key2last        = 17, key2first       = 18, key2module      = 19
                                                  
        if ack2debug is True:    
            print("\n (Step 11B/33) OF ZAP0010SIX4XI - UPDATED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
            print("\n (Step 11C/33) OF ZAP0010SIX4XI - KB0010SIX2PUT: ", kb0010six2put)
            # {'-16x7y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x7y-9z', 5: '#BEF781', 6: 61, 7: 10, 8: Decimal('19.6468827044'), 9: Decimal('9'), 10: 6, 11: '{passed; object-passed-to-sense-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense_object4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-16x6y-9z', 16: '-17x44y-51z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'sense_object4xi.py'}, '8xi': {}, '4xi': {}}, 
            #'-15x45y-50z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x45y-50z', 5: '#4C7094', 6: 42, 7: 30, 8: Decimal('68.9202437605'), 9: Decimal('58'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-14x11y-8z', 16: '-15x8y-8z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-13x12y-7z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x12y-7z', 5: '#4C7094', 6: 7, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-12x13y-7z', 16: '-13x12y-8z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-12x13y-7z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-12x13y-7z', 5: '#4C7094', 6: 6, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-11x47y-49z', 16: '-13x12y-7z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-13x12y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x12y-8z', 5: '#4C7094', 6: 12, 7: 30, 8: Decimal('19.4164878389'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-13x12y-7z', 16: '-13x46y-50z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            #  '-16x5y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x5y-9z', 5: '#4C7094', 6: 57, 7: 30, 8: Decimal('19.0262975904'), 9: Decimal('9'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-16x4y-9z', 16: '-16x6y-9z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-14x11y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-14x11y-8z', 5: '#4C7094', 6: 41, 7: 30, 8: Decimal('19.5192212959'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-14x10y-8z', 16: '-15x45y-50z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            #  '-15x8y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x8y-8z', 5: '#4C7094', 6: 43, 7: 30, 8: Decimal('18.7882942281'), 9: Decimal('8'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-15x45y-50z', 16: '-15x9y-8z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            #  '-16x6y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x6y-9z', 5: '#BEF781', 6: 60, 7: 10, 8: Decimal('19.3132079158'), 9: Decimal('9'), 10: 6, 11: '{started; sense-object4xi-started: function sense_object4xi at 0x02A5F780; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'sense_object4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-16x5y-9z', 16: '-16x7y-9z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'sense_object4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-14x10y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-14x10y-8z', 5: '#4C7094', 6: 14, 7: 30, 8: Decimal('18.973665961'), 9: Decimal('8'), 10: 6, 11: '{returning; z2xi-returning-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-13x46y-50z', 16: '-14x11y-8z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-13x46y-50z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-13x46y-50z', 5: '#4C7094', 6: 13, 7: 30, 8: Decimal('69.1736944221'), 9: Decimal('59'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-13x12y-8z', 16: '-14x10y-8z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            #   '-16x4y-9z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-16x4y-9z', 5: '#4C7094', 6: 56, 7: 30, 8: Decimal('18.7882942281'), 9: Decimal('8'), 10: 6, 11: '{(Step 2/3) got; z2xi-got-by-get-zskeleton4xi: z2xi; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-15x9y-8z', 16: '-16x5y-9z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-17x44y-51z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-17x44y-51z', 5: '#BEF781', 6: 62, 7: 10, 8: Decimal('69.4694177318'), 9: Decimal('59'), 10: 6, 11: "{returning; kb2xi-returning-by-sense-object4xi: {'object': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'sense_object4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-16x7y-9z', 16: '+0x+0y+0z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'sense_object4xi.py'}, '8xi': {}, '4xi': {}}, 
            # '-11x47y-49z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-11x47y-49z', 5: '#4C7094', 6: 5, 7: 30, 8: Decimal('68.7822651561'), 9: Decimal('58'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-0x-0y-0z', 16: '-12x13y-7z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}, 
            #   '-15x9y-8z': {'2xi': {1: 6, 2: 10, 3: {1: 157.07963267948966, 2: '#9A9591', 3: 15, 4: 10.471975511965978}, 4: 'dragon-15x9y-8z', 5: '#4C7094', 6: 55, 7: 30, 8: Decimal('19.2353840617'), 9: Decimal('9'), 10: 6, 11: '{(Step 1/3) started; get-zskeleton4xi-started: function get_zskeleton4xi at 0x02A5F810; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'get_zskeleton4xi', 13: 1, 14: '-0x-0y-0z',
            #                       15: '-15x8y-8z', 16: '-16x4y-9z', 17: '-17x44y-51z', 18: '-11x47y-49z', 19: 'zskeleton4xi.py'}, '8xi': {}, '4xi': {}}}

    except:        
        print("\n (Step 10Z2/33) OF ZAP0010SIX4XI *** FAILED TO EMBED NEXT AND PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0010 OF DIRECTION SIX")
        message2print = "{(Step 10Z2/33) failed" + "; kb0010six2put-failed-by-zap0010six4xi: " + str(kb0010six2put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) PUT KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------------------                   
    try:
        queue0010six.put(kb0010six2put)
        ack0010put4six = True  
        if ack2debug is True:                                                                                                       # 
            print("\n (Step 21A/33) OF ZAP0010SIX4XI - SUCCEEDED TO PUT LAYER 0010 TO QUEUE: ", queue0010six, " KB2PUT: ", kb0010six2put)
            # 
       
        # minimize trace after module test:
        message2print = "{(Step 21B/33) put" + "; kb0010six2put-put-by-zap0010six4xi: " + str(kb0010six2put)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          #
                    
    except:                                                                                                                
        print("\n (Step 21C/33) OF ZAP0010SIX4XI *** FAILED TO SET LAYER 0010 TO QUEUE0010SIX: ", queue0010six, " KB2PUT: ", kb0010six2put)                                                                                                         
        message2print = "{(Step 21C/33) failed" + "; queue0010six-put-failed-by-zap0010six4xi: " + str(queue0010six.put) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
           
    # -------------------------------------------------------------------------------------------------
    # (Step 20/33) MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------------------   
    if ack2debug is True:
        print("\n (Step 20A/33) OF ZAP0010SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL0010SIX: ", publisher_channel0010six)
                                                                                                                                    # 
    if ack0010put4six is True:
        message2send4six = "<ack0010put4six4xi>layer0010six</ack0010put4six4xi>"
    else:
        message2send4six = "<nack0010put4six4xi>layer0010six</nack0010put4six4xi>" 
    message2print = "{(Step 20B/33) set" + "; message2send4six-set-by-zap0010six4xi to: " + str(message2send4six)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                              #       
     
                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) SEND MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------------------                        
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel0010six.send(message2send4six)
        if ack2debug is True:     
            print("(Step 21A/33) OF ZAP0010SIX4XI -  SENT MESSAGE2SEND4SIX: ", message2send4six, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel0010six, " - TIME: ", time4xi()) 
                                                                                                                                    # 
        message2print = "{(Step 21B/33) sent" + "; message2send4six-sent-by-zap0010six4xi: " + str(message2send4six)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          #  
    except:
        print("(Step 21C/33) OF ZAP0010SIX4XI *** FAILED TO SEND MESSAGE2SEND4SIX: ", message2send4six, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel0010six, " - TIME: ", time4xi()) 
        message2print = "{(Step 21C/33) failed" + "; message2send4six-failed-by-zap0010six4xi: " + str(message2send4six) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                          # 
        
         
    # -------------------------------------------------------------------------------------------------
    # (Step 22/33) RETURN QUEUE OF LAYER 0010 OF DIRECTION SIX 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:        
        print("\n (Step 22A/33) OF ZAP0010SIX4XI - RETURNING QUEUE OBJECT QUEUE0010SIX: ", queue0010six, " - TIME: ", time4xi()) 
         
    message2print = "{(Step 22B/33) returning" + "; queue0010six-returning-by-zap0010six4xi: " + str(queue0010six) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                              # 
        
    return queue0010six    
        
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   zap2actor4xi.py
#   test_zap2actor4xi.py
#   test_zap2actor4xi.txt
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#   scope-sense*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0010six4xi.py                           
# ------------------------------------------------------------------------------------------------- 
#"
#/>
